/* Declare comove.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_COMOVE_H__



// signals file inclusion
#define __3DFC_COMOVE_H__



class CComponentMove : public CNodeComponent {

public:

   CComponentMove ();

private:
   
   tagfXYZ m_stDirection;    // direction vector - how much position offset each time
   tagfXYZ m_stAcceleration; // acceleration vector - how much direction offset each time
   BYTE m_yAX;    // rotation angles
   BYTE m_yAY;
   BYTE m_yAZ;

   // Setup what object slot activate (and with what parametes) case collision
   // with solid poly is detected or portal crossing.
   // Array format:
   // the first element is the slotID, the second the
   // pData1 value, third is pData2 value; pData3 is a pointer to the collided poly.
   DWORD m_adwCaseSolidCollide [ 3 ];    // setup case detected collision,
                                         // if slotID is SLOT_UNKNOWN, is only executed
                                         // default action - go back - with no more slot
                                         // activation.
   DWORD m_adwCasePortalCross [ 3 ];   // setup case portal crossing
                                       // if slotID is SLOT_UNKNOWN, is only executed 
                                       // default action - portal cross - with no more
                                       // slot activation.

   CMath m_oMath;            // for collision detection

   void mChangeSector ( CNodeSector* poDestSector );
   PTRVAL mDoMove ();

public:

   PTRVAL mActivate ( PTRVAL pData1, PTRVAL pData2, PTRVAL pData3 );
};



// end declarations
#endif
