/* Declare all 3DFC classes and data. Include in your own projects. */



#include "src/defs.h"

#include "src/array.h"

#include "src/mem.h"

#ifdef TRG_DOSDJGPP
#include "src/debug.h"
#include "src/port/keycodes.h"
#include "src/port/dosdjgpp/keyboard.h"
#include "src/port/dosdjgpp/gr.h"
#endif

#ifdef TRG_LINUXXWIN
#include "src/port/keycodes.h"
#include "src/port/linxwin/keyboard.h"
#endif

#include "src/node.h"
#include "src/list.h"

#include "src/polygon.h"

#include "src/nodelii.h"
#include "src/nodeint.h"
#include "src/nodepol.h"
#include "src/nodeptrv.h"

#include "src/math.h"
#include "src/heap.h"
#include "src/queue.h"
#include "src/map.h"
#include "src/refsys.h"
#include "src/camsys.h"
#include "src/eventtab.h"

#include "src/string.h"
#include "src/socket.h"
#include "src/svsocket.h"
#include "src/texture.h"
#include "src/mesh.h"
#include "src/sector.h"
#include "src/lighttab.h"

#include "src/nodesec.h"

#include "src/object.h"
#include "src/file.h"
#include "src/filerem.h"
#include "src/filepcx.h"
#include "src/filetxe.h"
#include "src/scenery.h"

#include "src/nodetex.h"
#include "src/nodexy.h"
#include "src/nodexyz.h"
#include "src/nodeflo.h"
#include "src/nodeobj.h"
#include "src/nodelgt.h"
#include "src/nodelist.h"

#include "src/neuron.h"
#include "src/bpn.h"
#include "src/nodenet.h"

#include "src/draw/draw.h"

#include "src/render/render.h"
#include "src/engine.h"

#ifdef TRG_LINUXXWIN
#include "src/port/linxwin/xwinapp.h"
#else
#include "src/port/screen.h"
#endif

#include "src/comp/nodecomp.h"
#include "src/nodestr.h"

#include "src/comp/cokbcont.h"
#include "src/comp/codata.h"
#include "src/comp/cosecset.h"
#include "src/comp/comesh.h"
#include "src/comp/cocamsys.h"
#include "src/comp/comove.h"
#include "src/comp/cofuncha.h"

