/* Declare screen.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_SCREEN_H__



// signals file inclusion
#define __3DFC_SCREEN_H__



class CScreen {

public:

   CScreen ( DWORD dwScreenMode );
   CScreen ();
   ~CScreen ();

protected:

   DWORD m_dwScreenMode;       // current Screen mode
   
   #ifdef TRG_DOSDJGPP
      CGr* m_poGr;             // low level graphics functions
   #endif

public:

   void mCreate ( DWORD dwScreenMode );
   void mDestroy ();
   void mShow ( CMem& oMem );
   void mSetPalette ( CMem& oMem );
};



// end declarations
#endif
